"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The ArduinoDashboardshare model module.
 * @module model/ArduinoDashboardshare
 * @version 1.3.8
 */
var ArduinoDashboardshare = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ArduinoDashboardshare</code>.
   * ArduinoDashboardshare media type (default view)
   * @alias module:model/ArduinoDashboardshare
   * @param userId {String} The userID of the user you want to share the dashboard with
   * @param username {String} The username of the user you want to share the dashboard with
   */
  function ArduinoDashboardshare(userId, username) {
    _classCallCheck(this, ArduinoDashboardshare);

    ArduinoDashboardshare.initialize(this, userId, username);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(ArduinoDashboardshare, null, [{
    key: "initialize",
    value: function initialize(obj, userId, username) {
      obj['user_id'] = userId;
      obj['username'] = username;
    }
    /**
     * Constructs a <code>ArduinoDashboardshare</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ArduinoDashboardshare} obj Optional instance to populate.
     * @return {module:model/ArduinoDashboardshare} The populated <code>ArduinoDashboardshare</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ArduinoDashboardshare();

        if (data.hasOwnProperty('user_id')) {
          obj['user_id'] = _ApiClient["default"].convertToType(data['user_id'], 'String');
        }

        if (data.hasOwnProperty('username')) {
          obj['username'] = _ApiClient["default"].convertToType(data['username'], 'String');
        }
      }

      return obj;
    }
  }]);

  return ArduinoDashboardshare;
}();
/**
 * The userID of the user you want to share the dashboard with
 * @member {String} user_id
 */


ArduinoDashboardshare.prototype['user_id'] = undefined;
/**
 * The username of the user you want to share the dashboard with
 * @member {String} username
 */

ArduinoDashboardshare.prototype['username'] = undefined;
var _default = ArduinoDashboardshare;
exports["default"] = _default;